#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include <syslog.h>
#include <sys/socket.h>
//#include <netinet/in.h>

#include <sys/un.h>

#define MAX_BUF 127

#define SOK_FILE "/tmp/local"
#define PORT	1502

static char buf[MAX_BUF];
/*   */
static int  k = 23; /*   */ 
static int sd;      /*   */
static int i,j,n;

main(int ac,char** av)
{
 int bs, s_len, i, j;
 struct sockaddr_un s_a;

 sd = socket(AF_UNIX,SOCK_STREAM,0); /*   */
 if( sd< 0 ){ fprintf(stderr,"telxnet: ERROR: Can not open socket\n"); exit(1); }

 bzero(&s_a,sizeof s_a);
 s_a.sun_family = AF_UNIX;
 strcpy(s_a.sun_path,SOK_FILE);
 s_len = sizeof s_a.sun_family + strlen(s_a.sun_path);

 if(connect(sd,(struct sockaddr*)&s_a,s_len)<0)
 { fprintf(stderr,"telxnet: ERROR: Can not connect to server\n"); exit(2); }

 printf(">> ");
 
 while( fgets(buf,sizeof buf - 1,stdin) )
 {
  char c = 1;

  if( buf[strlen(buf)-1]!='\n' ) break;
  
  if( strcmp("exit\n",buf)==0 ) break;

  write(sd,buf,strlen(buf) );
  
  while( 1 )
  {
     i=read(sd,&c,1);
     if( i<0 ) goto Exit;
     if( i )
     {
      if( c=='\0' ) break;
      write(1,&c,1);
     } 
  }
  
  printf(">> ");   
 } 
 Exit:
 i = 0;
 write(sd,&i,1);
 close(sd);
}

