#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <sys/types.h>
#include <syslog.h>
#include <sys/socket.h>
//#include <netinet/in.h>
#include <error.h>
extern int errno;

#include <sys/un.h>
#include <wait.h>

#define SOK_FILE "/tmp/local"

#define PORT	1502

#define EXIT { k=0; write(ns,&k,1); goto Exit;}

main()
{
 int bs, s_len, c_len, max_len, sd, c;
 struct sockaddr_un s_a,c_a;

// close(1); close(2); 
 
 openlog("telxnetd",LOG_PID | LOG_CONS, LOG_DAEMON);
 syslog(LOG_INFO,"i do work");
 
 sd = socket(AF_UNIX,SOCK_STREAM,0); /*   */
 if( sd< 0 ){ syslog(LOG_ERR,"ERROR: Can not open socket"); exit(1); }

 unlink(SOK_FILE);
 s_len = sizeof(s_a);
 bzero(&s_a,s_len);
 s_a.sun_family = AF_UNIX;
 strcpy(s_a.sun_path,SOK_FILE);
 s_len = sizeof(s_a.sun_family)+strlen(s_a.sun_path);
// s.sin_port = htons((u_short) PORT);
// s.sin_addr.s_addr = INADDR_ANY;
 
 bs = bind(sd,(struct sockaddr*) &s_a,s_len); /*    */
 if( bs<0 ) { syslog(LOG_ERR,"ERROR: Can not bild socket `%s'",strerror(errno)); exit(2);}
 /*    */
 if(listen(sd,5)<0){ syslog(LOG_ERR,"ERROR: Can not listen socket"); exit(2); }
 
 for(;;)
 {
 int ns, pid;
  c_len = sizeof c_a;
  bzero(&c_a,sizeof c_a);
  
  ns = accept(sd,(struct sockaddr*) &c_a,&c_len); /*   */
  if( ns<0 ){ syslog(LOG_ERR,"ERROR: Can not bind socket"); exit(3);}
  
  syslog(LOG_INFO,"Accept...");

  pid = fork();
  if( pid==-1 ){ syslog(LOG_ERR,"ERROR: Can not create process"); exit(4);}
 
  if( pid==0 ) /*   */
  {
   int k, p[2], e[2], i, i2;
   int n = 0;
   char* argv[64];
   char buf[127];
   int status;
   
   close(sd); /*      -     */ 

while( 1 ){
   char* s = buf;

   while( 1 )  /*     buf */
   {    
   i=read(ns,s,1);
    if( i<0 ) goto Exit;
    if( i==1 )
    {
     if( *s=='\0' ) goto Exit;
     else if( *s=='\n' ) break;
     s++;
    } 
   }
   
   *s = '\0'; /*    0- */
   
   argv[0] = strtok(buf," \t"); /*      */
   if( argv[0]==0 ){ k=0; write(ns,&k,1); continue;}
   
   for( i=1; i<63; i++) 
   {
     argv[i] = strtok(NULL," \t");
     if( argv[i]==0 ) break;
   }
   
   argv[i] = 0;
   
   if( strcmp("cd",argv[0])==0 ) /*   */
   {
    char* s;
    if( argv[1]==0 ) argv[1] = "~";
    if( chdir(argv[1])==-1 )
    s = strerror(errno), write(ns,s,strlen(s)), write(ns,"\n",1);
    k = 0;
    write(ns,&k,1);
    continue;
   }

    /*      */
   
   i = pipe(e);
   if( i<0 ){ syslog(LOG_ERR,"pipe err not create"); EXIT; }

   i = pipe(p);
   if( i<0 ){ syslog(LOG_ERR,"pipe out not create"); EXIT;}
   

    if( (pid=fork())==0 ) /*   */
    {
     close(ns);
     if( dup2(p[1],1)<0 ){ syslog(LOG_ERR,"child: error create stdout"); EXIT;}
     if( dup2(e[1],2)<0 ){ syslog(LOG_ERR,"child: error create stderr"); EXIT;}
     close(p[0]); 	/*      */
     close(e[0]);
     execvp(argv[0],argv); /*    */
     perror("telxnetd");
     write(2,s="telxnetd: Command not found\n",strlen(s));
     exit( 1 );
    }
    
    close(p[1]); /*      */
    close(e[1]);

    while( read(p[0],&c,1)>0 ) /*     */

       write(ns,&c,1); /*    */


close( p[0] );

       while( read(e[0],&c,1)>0 ) /*     */

       write(ns,&c,1); /*    */

close( e[0] );


   waitpid(pid,&status,WNOHANG);/*WUNTRACED);    /*   */
   status = WEXITSTATUS(status);      /*      */
//   if( status > 0 ) 
   
   k = 0;
   write(ns,&k,1);
   
} /* while end */
Exit:
   syslog(LOG_INFO,"Disconnect...");
   close(ns);
   exit(0);
  }
  
  waitpid(pid,0,WUNTRACED);
  close(ns); /*        */ 
 }
 close(sd);
 closelog();
}

