#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include <syslog.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netdb.h>

#define MAX_BUF 127

#define PORT	1502

static char buf[MAX_BUF];
/*   */
static int  k = 23; /*   */ 
static int sd;      /*   */
static int i,j,n;

main(int ac,char** av)
{
 int bs, s_len, i, j;
 struct sockaddr_in s_a;
 struct hostent *hp;

 if( ! av[1] ) fprintf(stderr,"telxnet: Empty in argv[1]\n"), exit(1);

 hp = gethostbyname(av[1]);
 if( !hp ) perror("telxnet"), exit(2);

 sd = socket(AF_INET,SOCK_STREAM,0); /*   */
 if( sd< 0 ){ fprintf(stderr,"telxnet: ERROR: Can not open socket\n"); exit(1); }

 bzero(&s_a,sizeof s_a);
 bcopy(hp->h_addr,&s_a.sin_addr,hp->h_length);
 s_a.sin_family = AF_INET;
 s_a.sin_port = htons((u_short) PORT);

 if(connect(sd,(struct sockaddr*)&s_a,sizeof s_a)<0)
 { fprintf(stderr,"telxnet: ERROR: Can not connect to server\n"); exit(2); }

 printf(">> ");
 
 while( fgets(buf,sizeof buf - 1,stdin) )
 {
  char c = 1;

  if( buf[strlen(buf)-1]!='\n' ) break;
  
  if( strcmp("exit\n",buf)==0 ) break;

  write(sd,buf,strlen(buf) );
  
  while( 1 )
  {
     i=read(sd,&c,1);
     if( i<0 ) goto Exit;
     if( i )
     {
      if( c=='\0' ) break;
      write(1,&c,1);
     } 
  }
  
  printf(">> ");   
 } 
 Exit:
 i = 0;
 write(sd,&i,1);
 close(sd);
}

